<script setup lang="ts">
import { useMaterialStore } from '@/stores/material'

import { nextTick, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const materialStore = useMaterialStore()
const refForm = ref<VForm | null>(null)
let qtyIm = 0
let qtyImNum = 0

async function update() {
  const { valid } = await refForm.value!.validate()
  if (valid) {
    materialStore.updateDialog = false

    materialStore.material.forEach((item, index) => {
      let qtyIm = materialStore.material[index].material_Im
      let qtyImNum = typeof qtyIm === 'string' ? parseInt(qtyIm) || 0 : 0

      materialStore.material[index].material_qty += qtyImNum
      materialStore.material[index].material_Im = 0

      materialStore.tableStock[index] = { ...materialStore.material[index] }
    })
  }
}
</script>
<template>
  <v-row justify="center">
    <v-dialog v-model="materialStore.updateDialog" persistent width="700px" height="700px">
      <v-card>
        <v-card-title class="text-h5 text-center"> Import Stock </v-card-title>
        <v-card-text>
          <v-form ref="refForm">
            <v-table fixed-header height="550px" style="overflow: auto">
              <thead>
                <tr>
                  <th class="text-center">ID</th>
                  <th class="text-center">Name</th>
                  <th class="text-center">Quantity in Stock(Now)</th>
                  <th class="text-center">Quantity Import</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="item of materialStore.material" :key="item.material_id" editedIndex="item.id">
                  <td class="text-center">{{ item.material_id }}</td>
                  <td class="text-center">{{ item.material_name }}</td>
                  <td class="text-center">{{ item.material_qty }}</td>
                  <td class="text-center">
                    <v-text-field
                      :rules="[(v) => !!v || 'Field is required']"
                      label="Import"
                      required
                      hide-details
                      v-model="item.material_Im"
                    >
                    </v-text-field>
                  </td>
                </tr>
              </tbody>
            </v-table>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <div>
            <v-spacer></v-spacer>
            <v-btn
              color="green-darken-1"
              variant="text"
              @click="(materialStore.updateDialog = false), (qtyIm = 0)"
            >
              Cancel
            </v-btn>
            <v-btn color="green-darken-1" variant="text" @click="update()"> Update </v-btn>
          </div>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>
